<?php
/**
 * update XH content to 1.6 
 *
 * @author svasti <svasti@svasti.de>
 * @date 2014-02-19
 * @version 3
 */

function delete($object)
{
    if (is_file($object)) {
        echo 'Trying to delete '.$object.'.<br>';
        unlink($object);
    }

    if (is_dir($object)) {
        $files = scandir($object);
            foreach ($files as $file) {
                if ($file != "." && $file != "..") {
                    if (filetype($object."/".$file) == "dir") delete($object."/".$file); else {
                        unlink($object."/".$file);
                    }
                }
            }
         reset($files);
         rmdir($object);
     }

    if(is_file($object) || is_dir($object)) {
        echo 'Deletion of '.$object.' not possible.<br>Please <b>delete it manually.</b><br>';
        return FALSE;
    } else {
        echo 'Successfully deleted '.$object.'<br>';
        return TRUE;
    }
}


function move($old,$new)
{
    if(rename($old,$new)===TRUE) {
        echo 'Moved '.$old.' to '.$new.'.<br>';
        return TRUE;
    } else {
        echo 'Moving '.$old.' to '.$new.' <b>FAILED.</b><br>
        Trying to copy the files instead.<br>';

        if(file_put_contents($new,'') !== FALSE) {
            echo 'Created empty '.$new.'.<br>';
            if (copy($old,$new)===TRUE) {
                echo 'Copied '.$old.' to '.$new.'.<br>';
                delete($old);
                return TRUE;
            } else echo 'Couldn\'d copy '.$old.' to '.$new.'.<br>';
        } else echo 'Couldn\'t create an empty '.$new.'. Please move '.$old.' manually and <b>run script again.</b><br>';
    }
}


function check($file,$lang)
{
    global $cf;
    if(!is_file('./' . $cf['folders']['content'] . $lang . $file)) {
        echo 'No ./' . $cf['folders']['content'] . $lang . $file . ' found.<br>Skipping this folder.<br><br>';
        return FALSE;
    }
    if(!is_writable('./' . $cf['folders']['content'] . $lang . $file)) {
        echo 'No writing permission for ./' . $cf['folders']['content'] . $lang . $file . '.<br>
              Please <b>give writing permissions</b> (via ftp) and run update.php again.<br><br>';
        return FALSE;
    }
    return TRUE;
}


function migrate($lang)
{
	global $cf;

    $move_ok = 0;

    if(is_file('./'.$lang.'/content/content.htm')) {
        echo 'Found ./'.$lang.'/content/content.htm.<br>';
        $move_ok++;
    } else {
        echo 'Couldn\'t find ./'.$lang.'/content/content.htm.<br>';
    }
    if(is_file('./'.$lang.'/content/pagedata.php')) {
        echo 'Found ./'.$lang.'/content/pagedata.php.<br>';
        $move_ok++;
    } else {
        echo 'Couldn\'t find ./'.$lang.'/content/pagedata.php.<br>';
    }

    if($move_ok) {

        echo 'Trying to move these files.<br>';

        if(!is_file('./'.$lang.'/.2lang')) {
           if(file_put_contents('./'.$lang.'/.2lang','') !== FALSE) {
              echo 'Created file '. $lang.'/.2lang.<br>';
           } else echo 'FAILED to create file '. $lang.'/.2lang.<br>
                        Please create this empty file manually via ftp.<br><br>';
        }

        if(move('./'.$lang.'/content/content.htm','./'. $cf['folders']['content'].$lang.'/content.htm')) $move_ok++;
        if($move_ok == 3 && move('./'.$lang.'/content/pagedata.php','./'. $cf['folders']['content'].$lang.'/pagedata.php')) $move_ok++;

        if($move_ok == 4) {
            delete('./'.$lang.'/content');
        }
    }
    echo '<br>';
}


function update($lang='')
{
    global $cf;

    // check if conditions for action are set
    //==========================================

    if(!check('content.htm',$lang)) return NULL;
    if(!check('pagedata.php',$lang)) return NULL;

    $content  = file_get_contents('./' . $cf['folders']['content'] . $lang . 'content.htm');

    // check if pagedata are already in the content.htm
    if(strpos($content,'$page_data[]=array(')) {
        echo './'.$cf['folders']['content'].$lang.'content.htm contains already page data.<br>Skipping this folder.<br><br>';
        return NULL;
    }
    // End of preliminary part --------------------------------


    // adjust links and count changes
    //=================================

    $extradot = $lang? '.' : '';

    // image links

    $pattern = $lang
        ? '/src=(["\'])(?:\.\/)?\.\.\/images\//U'
        : '/src=(["\'])(?:\.\/)?images\//U';
    $replacement = 'src=${1}'.$extradot.'./'.$cf['folders']['userfiles'].$cf['folders']['images'];
    $content = preg_replace($pattern,$replacement,$content,-1,$count);
    if(intval($count)) {
        echo intval($count)
        . ' times standard image link in content.htm adjusted from '.$extradot.'./images to '.$extradot.'./'
        . $cf['folders']['userfiles'] . $cf['folders']['images'] . '<br>';
    } else echo 'No standard image links found.<br>';

    // zoom image links

    $pattern = $lang
        ? '/href=(["\'])(?:\.\/)?\.\.\/images\//U'
        : '/href=(["\'])(?:\.\/)?images\//U';
    $replacement = 'href=${1}'.$extradot.'./'.$cf['folders']['userfiles'].$cf['folders']['images'];
    $content = preg_replace($pattern,$replacement,$content,-1,$count);
    if(intval($count)) {
        echo intval($count)
        . ' times href image link in content.htm adjusted from '.$extradot.'./images to '.$extradot.'./'
        . $cf['folders']['userfiles'] . $cf['folders']['images'] . '<br>';
    }

    // downloads links

    $pattern = $lang
        ? '/href=(["\'])(?:\.\/)?\.\.\/downloads\//U'
        : '/href=(["\'])(?:\.\/)?downloads\//U';
    $replacement = 'href=${1}'.$extradot.'./'.$cf['folders']['userfiles'].$cf['folders']['downloads'];
    $content = preg_replace($pattern,$replacement,$content,-1,$count);
    if(intval($count)) {
        echo intval($count)
        . ' times downloads link in content.htm adjusted from '.$extradot.'./downloads to '.$extradot.'./'
        . $cf['folders']['userfiles'] . $cf['folders']['downloads'] . '<br>';
    }

    // media links

    $pattern = $lang
        ? '/href=(["\'])(?:\.\/)?\.\.\/media\//U'
        : '/href=(["\'])(?:\.\/)?media\//U';
    $replacement = '<href=${1}'.$extradot.'./'.$cf['folders']['userfiles'].$cf['folders']['media'];
    $content = preg_replace($pattern,$replacement,$content,-1,$count);
    if(intval($count)) {
        echo intval($count)
        . ' times media link in content.htm adjusted from '.$extradot.'./downloads to '.$extradot.'./'
        . $cf['folders']['userfiles'] . $cf['folders']['media'] . '<br>';
    }

    // End of link adjustments -------------------------------------------------



    // integrate old pagedata.php into content.htm
    //================================================

    include_once './' . $cf['folders']['content'] . $lang . 'pagedata.php';

    //splitting the content into pages and headers

    $contentarray = preg_split('/(<h[1-'.$cf['menu']['levels'].'].*<\/h[1-'.$cf['menu']['levels'].']>)/Usi',$content,-1, PREG_SPLIT_DELIM_CAPTURE);

    // modifying the first array value
    // adding page_data_fields
    $contentarray[0] = '<html><head><title>Content file</title>' . "\n" . '<?php' . "\n" . '$page_data_fields=array(';
    foreach ($page_data_fields as $key=>$value) {
    	$contentarray[0] .= "'" . $value . "',";
    }
    $contentarray[0] = rtrim($contentarray[0], ',');
    $contentarray[0] .= ');' . "\n" . '$temp_data=array(';
    // adding temp data
    if(count($temp_data)) {
        foreach ($temp_data as $key=>$value) {
        	$contentarray[0] .= "\n'" . $key . "'=>'" . $value . "',";
        }
    }
    $contentarray[0] = rtrim($contentarray[0], ',');
    $contentarray[0] .= "\n);\n" . '?' . '>' ."\n" . '</head><body>' ."\n";


    // glueing the headers to the preceding pages
    // and creating an array ending in a header
    foreach ($contentarray as $key=>$value) {
        if ($key % 2) {
            $contentarray[$key-1] .= $value;
            $c[] = $contentarray[$key-1];
        }
    }
    // last page is missing, as no header follows. Will be added later.

    // adding the pagedata fields after each header, i.e. at the end of each array value
    foreach ($c as $key=>$value) {
        $_pagedata = '';
        $_pagedata = "\n" . '<?php' ."\n" . '$page_data[]=array(';
        foreach ($page_data[$key] as $pdkey=>$pdvalue) {
        	$_pagedata .= "\n'" . $pdkey ."'=>'" . $pdvalue ."',";
        }
        $_pagedata = rtrim($_pagedata,',');
        $_pagedata .= "\n);\n" . '?' . '>';
        $c[$key] .= $_pagedata;
    }

    $content = implode($c);

    // add end part
    $x = count($contentarray)-1;
    $content .= $contentarray[$x];

    // save content
    if(file_put_contents('./' . $cf['folders']['content'] . $lang . 'content.htm',$content)) {
        echo './'.$cf['folders']['content'].$lang.'pagedata.php integrated into ./'.$cf['folders']['content'].$lang.'content.htm.<br>';
        delete('./' . $cf['folders']['content'] . $lang . 'pagedata.php');
    } else echo 'ERROR: New ./'.$cf['folders']['content'].$lang.'content.htm could not be saved.<br>'
               .'You may try to give higher permissions and run the script again or complete the update manually.<br>';
    echo '<br>';
}



function servertest()
{
    global $cf,$sec_lang_array;

// correct php version?

    if (version_compare(phpversion(), '5', '<')) {
        echo 'Your PHP version is only ' . PHP_VERSION . ' and thus too low for this script.<br>
        Either try to have your server set to PHP 5 or do the update manually.';
        return false;
    }

// find out if there are secondary languages and check permissions

    $err = 0;
    foreach ($sec_lang_array as $key=>$lang) {
        if(!is_writable('./'.$lang) || !is_writable('./'.$lang.'/content/')) {
            echo '"'.$lang.'" folder or "'.$lang.'/content" folder <b>not writable.</b><br>
                 Please <b>give writing permissions</b> (via ftp) and run update.php again.<br><br>';
            $err++;
        }

    }

// check permissions also in standard content folder

    if(!is_writable('./' . $cf['folders']['content'] )) {
        echo 'No writing permission for ./' . $cf['folders']['content'] . $lang . $file . '.<br>
              Please <b>give writing permissions</b> (via ftp) and run update.php again.<br><br>';
        $err++;
    }

    if($err) {
        return false;
    } else {
        foreach ($sec_lang_array as $key=>$lang) {

// check if new subfolders for the secondary languages can be created and if files can be created in them

            if(!is_dir('./' . $cf['folders']['content'] . $lang)) {
                if(mkdir('./' . $cf['folders']['content'] . $lang)) {
                    // create file to test system
                    if(file_put_contents('./' . $cf['folders']['content'] . $lang . '/content.htm','') === FALSE) {
                        // folder could be created, but no files in it. Folder has to be created manually
                        rmdir('./' . $cf['folders']['content'] . $lang);
                        echo 'Please create folder ./' . $cf['folders']['content'] . $lang . ' manually via ftp<br>
                             and give necessary writing permissions and run update.php again.<br><br>';
                        $err++;
                    }
                } else {
                    // Folder counldn't be created
                    echo 'Please create folder ./' . $cf['folders']['content'] . $lang . ' manually via ftp,<br>
                         give writing permissions and run update.php again.<br><br>';
                    $err++;
                }
            } else {
                // Folder already present, check permissions
                if(!is_writable('./' . $cf['folders']['content'] . $lang )) {
                    echo 'No writing permission for ./' . $cf['folders']['content'] . $lang . '.<br>
                          Please <b>give writing permissions</b> (via ftp) and run update.php again.<br><br>';
                    $err++;
                } else {
                    // check if a file can be created that is writable
                    if(!is_file('./' . $cf['folders']['content'] . $lang . '/content.htm','')) {
                        file_put_contents('./' . $cf['folders']['content'] . $lang . '/content.htm','');
                    }
                    if(!is_writable('./' . $cf['folders']['content'] . $lang. '/content.htm' )) {
                        echo 'No writing permission for ./' . $cf['folders']['content'] . $lang. '/content.htm.<br>
                              Please <b>give writing permissions</b> (via ftp) and run update.php again.<br><br>';
                        $err++;
                    }
                }
            }
        }
    }
    return $err? false:true;
}


// START the programm
//=====================

echo 'This script updates content.htm + pagedata.php of XH 1.5 (including secondary languages)<br>
to integrated XH 1.6 content.htm files and adjusts paths of images, downloads and media.<br>
There are no user settings.<br><br><br>';

// load config values
include_once './cmsimple/config.php';

// check if secondary languages are there

$sec_lang_array=array();
if ($handle = opendir('./')) {
    while (false !== ($folder = readdir($handle))) {
        if (strlen($folder)==2 && $folder != '..' && is_dir('./'.$folder)) {
            $sec_lang_array[] = $folder;
        }
    }
    closedir($handle);
}


if(servertest()) {

// start working only after servertest gives its OK

    if(count($sec_lang_array)) echo 'Looking for old style secondary language files at domain base.<br><br>';
    foreach ($sec_lang_array as $key=>$lang) {
        migrate($lang);
    }

    // unify secondary language files

    echo 'Looking for secondary language files as subfolders of content.<br><br>';

    $i = 0;
    if ($handle = opendir('./'.$cf['folders']['content'])) {
        while (false !== ($folder = readdir($handle))) {
            if (strlen($folder)==2 && $folder != '..' && is_dir('./'.$cf['folders']['content'].$folder)) {
                $i++;
                echo 'Found "./'.$cf['folders']['content'].$folder.'" folder. Started working on it.</b><br>' ;
                update($folder.'/');
            }
        }
        closedir($handle);
    }
    if($i) echo 'All secondary language folders as subfolders of content (1.6 style) gone through.<br><br>';
    else echo 'No secondary language folder as subfolders of content (1.6 style) found.<br><br>';

    // Finish with the standard content.htm file

    echo 'Starting to work on standard content folder<br><br>';

    update();

    echo 'Finished working on standard content language.<br><br>';


    // End
    //==========

    echo 'Skript teminates.<br>';
    delete('./update.php');

}


?>
